Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_algo_ecmwf.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_algo_ecmwf.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_algo_ecmwf.F90	(revision 9125)
@@ -32,5 +32,4 @@
    USE iom             ! I/O manager library
    USE lib_mpp         ! distribued memory computing library
-   USE wrk_nemo        ! work arrays
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -118,15 +117,12 @@
       INTEGER , PARAMETER ::   nb_itt = 4       ! number of itterations
       !
-      REAL(wp), DIMENSION(:,:), POINTER  ::   u_star, t_star, q_star,   &
+      REAL(wp), DIMENSION(jpi,jpj) ::   u_star, t_star, q_star,   &
          &  dt_zu, dq_zu,    &
          &  znu_a,           & !: Nu_air, Viscosity of air
          &  Linv,            & !: 1/L (inverse of Monin Obukhov length...
          &  z0, z0t, z0q
-      REAL(wp), DIMENSION(:,:), POINTER ::   func_m, func_h
-      REAL(wp), DIMENSION(:,:), POINTER ::   ztmp0, ztmp1, ztmp2
-      !!----------------------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi,jpj,   u_star, t_star, q_star, func_m, func_h, dt_zu, dq_zu, Linv )
-      CALL wrk_alloc( jpi,jpj,   znu_a, z0, z0t, z0q, ztmp0, ztmp1, ztmp2 )
+      REAL(wp), DIMENSION(jpi,jpj) ::   func_m, func_h
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztmp0, ztmp1, ztmp2
+      !!----------------------------------------------------------------------------------
       !
       ! Identical first gess as in COARE, with IFS parameter values though
@@ -286,7 +282,4 @@
       Cen = vkarmn*vkarmn / (log(ztmp1/z0q)*log(ztmp1/z0q))
 
-      CALL wrk_dealloc( jpi,jpj,   u_star, t_star, q_star, func_m, func_h, dt_zu, dq_zu, Linv )
-      CALL wrk_dealloc( jpi,jpj,   znu_a, z0, z0t, z0q, ztmp0, ztmp1, ztmp2 )
-      !
    END SUBROUTINE TURB_ECMWF
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_algo_ncar.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_algo_ncar.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcblk_algo_ncar.F90	(revision 9125)
@@ -34,5 +34,4 @@
    USE iom             ! I/O manager library
    USE lib_mpp         ! distribued memory computing library
-   USE wrk_nemo        ! work arrays
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -118,14 +117,11 @@
       INTEGER , PARAMETER ::   nb_itt = 4       ! number of itterations
       !
-      REAL(wp), DIMENSION(:,:), POINTER ::   Cx_n10        ! 10m neutral latent/sensible coefficient
-      REAL(wp), DIMENSION(:,:), POINTER ::   sqrt_Cd_n10   ! root square of Cd_n10
-      REAL(wp), DIMENSION(:,:), POINTER ::   zeta_u        ! stability parameter at height zu
-      REAL(wp), DIMENSION(:,:), POINTER ::   zpsi_h_u
-      REAL(wp), DIMENSION(:,:), POINTER ::   ztmp0, ztmp1, ztmp2
-      REAL(wp), DIMENSION(:,:), POINTER ::   stab          ! stability test integer
-      !!----------------------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi,jpj,   Cx_n10, sqrt_Cd_n10, zeta_u, stab )
-      CALL wrk_alloc( jpi,jpj,   zpsi_h_u, ztmp0, ztmp1, ztmp2 )
+      REAL(wp), DIMENSION(jpi,jpj) ::   Cx_n10        ! 10m neutral latent/sensible coefficient
+      REAL(wp), DIMENSION(jpi,jpj) ::   sqrt_Cd_n10   ! root square of Cd_n10
+      REAL(wp), DIMENSION(jpi,jpj) ::   zeta_u        ! stability parameter at height zu
+      REAL(wp), DIMENSION(jpi,jpj) ::   zpsi_h_u
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztmp0, ztmp1, ztmp2
+      REAL(wp), DIMENSION(jpi,jpj) ::   stab          ! stability test integer
+      !!----------------------------------------------------------------------------------
       !
       l_zt_equal_zu = .FALSE.
@@ -223,7 +219,4 @@
       END DO
       !
-      CALL wrk_dealloc( jpi,jpj,   Cx_n10, sqrt_Cd_n10, zeta_u, stab )
-      CALL wrk_dealloc( jpi,jpj,   zpsi_h_u, ztmp0, ztmp1, ztmp2 )
-      !
    END SUBROUTINE turb_ncar
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 9125)
@@ -25,4 +25,5 @@
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! distribued memory computing library
+   USE timing         ! Timing
    USE lbclnk         ! ocean lateral boundary conditions
    USE lib_fortran    ! 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 9125)
@@ -18,5 +18,4 @@
    USE lib_mpp         ! distributed memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo        ! work arrays
    USE daymod          ! calendar
    USE fldread         ! read input fields
@@ -155,10 +154,8 @@
       !!---------------------------------------------------------------------
       INTEGER, INTENT( in  ) ::   ksbc                ! surface forcing type
-      REAL(wp), DIMENSION(:,:), POINTER :: ztmp1, ztmp2
+      REAL(wp), DIMENSION(jpi,jpj) :: ztmp1, ztmp2
       REAL(wp) ::   zcoefu, zcoefv, zcoeff            ! local scalar
       INTEGER  ::   ji, jj, jl, jk                    ! dummy loop indices
       !!---------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi,jpj, ztmp1, ztmp2 )
       !
       IF(lwp) WRITE(numout,*)'cice_sbc_init'
@@ -272,6 +269,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj, ztmp1, ztmp2 )
-      !
    END SUBROUTINE cice_sbc_init
 
@@ -286,12 +281,9 @@
       !
       INTEGER  ::   ji, jj, jl                   ! dummy loop indices      
-      REAL(wp), DIMENSION(:,:), POINTER :: ztmp, zpice
-      REAL(wp), DIMENSION(:,:,:), POINTER :: ztmpn
+      REAL(wp), DIMENSION(jpi,jpj) :: ztmp, zpice
+      REAL(wp), DIMENSION(jpi,jpj,ncat) :: ztmpn
       REAL(wp) ::   zintb, zintn  ! dummy argument
       !!---------------------------------------------------------------------
       !
-      CALL wrk_alloc( jpi,jpj, ztmp, zpice )
-      CALL wrk_alloc( jpi,jpj,ncat, ztmpn )
-
       IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)'cice_sbc_in'
@@ -492,7 +484,4 @@
       END DO
       CALL nemo2cice(ztmp,ss_tlty,'F', -1. )
-
-      CALL wrk_dealloc( jpi,jpj, ztmp, zpice )
-      CALL wrk_dealloc( jpi,jpj,ncat, ztmpn )
       !
    END SUBROUTINE cice_sbc_in
@@ -508,9 +497,7 @@
       
       INTEGER  ::   ji, jj, jl                 ! dummy loop indices
-      REAL(wp), DIMENSION(:,:), POINTER :: ztmp1, ztmp2
-      !!---------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi,jpj, ztmp1, ztmp2 )
-      
+      REAL(wp), DIMENSION(jpi,jpj) :: ztmp1, ztmp2
+      !!---------------------------------------------------------------------
+      !
       IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)'cice_sbc_out'
@@ -660,8 +647,4 @@
       snwice_mass_b(:,:) = snwice_mass(:,:)
       snwice_fmass (:,:) = ( snwice_mass(:,:) - snwice_mass_b(:,:) ) / dt
-
-! Release work space
-
-      CALL wrk_dealloc( jpi,jpj, ztmp1, ztmp2 )
       !
    END SUBROUTINE cice_sbc_out
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 9125)
@@ -27,5 +27,4 @@
    USE iom            ! I/O module
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory allocation
 
    IMPLICIT NONE
@@ -106,7 +105,6 @@
       INTEGER  ::   z_err = 0 ! dummy integer for error handling
       !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:), POINTER       ::   ztfrz   ! freezing point used for temperature correction
-      !
-      CALL wrk_alloc( jpi,jpj, ztfrz)
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztfrz   ! freezing point used for temperature correction
+      !
       !
       !                                            !-------------------!
@@ -169,6 +167,4 @@
          CALL iom_rstput( kt, nitrst, numrow, 'rnf_sc_b', rnf_tsc(:,:,jp_sal) )
       ENDIF
-      !
-      CALL wrk_dealloc( jpi,jpj, ztfrz)
       !
    END SUBROUTINE sbc_rnf
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 9125)
@@ -16,5 +16,4 @@
    USE ioipsl         ! NetCDF IPSL library
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
-   USE wrk_nemo       !
 
    IMPLICIT NONE
@@ -140,5 +139,5 @@
       INTEGER :: inum                 ! Logical unit of input file
       INTEGER :: ji, jj, itide        ! dummy loop indices
-      REAL(wp), POINTER, DIMENSION(:,:) ::   ztr, zti   !: workspace to read in tidal harmonics data 
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztr, zti   !: workspace to read in tidal harmonics data 
       !!----------------------------------------------------------------------
       IF(lwp) THEN
@@ -147,6 +146,4 @@
          WRITE(numout,*) '~~~~~~~~~~~~~~ '
       ENDIF
-      !
-      CALL wrk_alloc( jpi, jpj, zti, ztr )
       !
       CALL iom_open ( cn_tide_load , inum )
@@ -166,6 +163,4 @@
       CALL iom_close( inum )
       !
-      CALL wrk_dealloc( jpi, jpj, zti, ztr )
-      !
    END SUBROUTINE tide_init_load
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 9125)
@@ -27,5 +27,4 @@
    USE lib_mpp        ! distribued memory computing library
    USE fldread	       ! read input fields
-   USE wrk_nemo       !
 
    IMPLICIT NONE
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdmxl.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdmxl.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdmxl.F90	(revision 9125)
@@ -37,5 +37,4 @@
    USE restart         ! for lrst_oce
    USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! Memory allocation
    USE iom
 
@@ -253,8 +252,6 @@
       !
       INTEGER ::   ji, jj, jk, isum
-      REAL(wp), POINTER, DIMENSION(:,:)  :: zvlmsk 
-      !!----------------------------------------------------------------------
-
-      CALL wrk_alloc( jpi, jpj, zvlmsk ) 
+      REAL(wp), DIMENSION(jpi,jpj)  :: zvlmsk 
+      !!----------------------------------------------------------------------
 
       ! I. Definition of control surface and associated fields
@@ -280,6 +277,4 @@
 
       END IF
-      !
-      CALL wrk_dealloc( jpi, jpj, zvlmsk ) 
       !
    END SUBROUTINE trd_mxl_zint
@@ -339,13 +334,9 @@
       !                                              ! z(ts)mltot : dT/dt over the anlysis window (including Asselin)
       !                                              ! z(ts)mlres : residual = dh/dt entrainment term
-      REAL(wp), POINTER, DIMENSION(:,:  ) ::  ztmltot , zsmltot , ztmlres , zsmlres , ztmlatf , zsmlatf
-      REAL(wp), POINTER, DIMENSION(:,:  ) ::  ztmltot2, zsmltot2, ztmlres2, zsmlres2, ztmlatf2, zsmlatf2, ztmltrdm2, zsmltrdm2  
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztmltrd2, zsmltrd2   ! only needed for mean diagnostics
+      REAL(wp), DIMENSION(jpi,jpj  )   ::  ztmltot , zsmltot , ztmlres , zsmlres , ztmlatf , zsmlatf
+      REAL(wp), DIMENSION(jpi,jpj  )   ::  ztmltot2, zsmltot2, ztmlres2, zsmlres2, ztmlatf2, zsmlatf2, ztmltrdm2, zsmltrdm2  
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  ztmltrd2, zsmltrd2   ! only needed for mean diagnostics
       !!----------------------------------------------------------------------
   
-      CALL wrk_alloc( jpi, jpj,         ztmltot , zsmltot , ztmlres , zsmlres , ztmlatf , zsmlatf                        )
-      CALL wrk_alloc( jpi, jpj,         ztmltot2, zsmltot2, ztmlres2, zsmlres2, ztmlatf2, zsmlatf2, ztmltrdm2, zsmltrdm2 )  
-      CALL wrk_alloc( jpi, jpj, jpltrd, ztmltrd2, zsmltrd2                                                               )
-
       ! ======================================================================
       ! II. Cumulate the trends over the analysis window
@@ -719,7 +710,4 @@
       IF( lrst_oce )   CALL trd_mxl_rst_write( kt ) 
 
-      CALL wrk_dealloc( jpi, jpj,         ztmltot , zsmltot , ztmlres , zsmlres , ztmlatf , zsmlatf                        )
-      CALL wrk_dealloc( jpi, jpj,         ztmltot2, zsmltot2, ztmlres2, zsmlres2, ztmlatf2, zsmlatf2, ztmltrdm2, zsmltrdm2 )  
-      CALL wrk_dealloc( jpi, jpj, jpltrd, ztmltrd2, zsmltrd2                                                               )
       !
    END SUBROUTINE trd_mxl
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdpen.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdpen.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdpen.F90	(revision 9125)
@@ -24,5 +24,4 @@
    USE iom            ! I/O manager library
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory allocation
 
    IMPLICIT NONE
@@ -70,9 +69,8 @@
       !
       INTEGER ::   jk                                            ! dummy loop indices
-      REAL(wp), POINTER, DIMENSION(:,:)      ::   z2d            ! 2D workspace 
-      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   zpe            ! 3D workspace 
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)      ::   z2d            ! 2D workspace 
+      REAL(wp), DIMENSION(jpi,jpj,jpk)           ::   zpe            ! 3D workspace 
       !!----------------------------------------------------------------------
       !
-      CALL wrk_alloc( jpi, jpj, jpk, zpe )
       zpe(:,:,:) = 0._wp
       !
@@ -96,5 +94,5 @@
       CASE ( jptra_zad  )   ;   CALL iom_put( "petrd_zad", zpe )   ! vertical advection
                                 IF( ln_linssh ) THEN                   ! cst volume : adv flux through z=0 surface
-                                   CALL wrk_alloc( jpi, jpj, z2d )
+                                   ALLOCATE( z2d(jpi,jpj) )
                                    z2d(:,:) = wn(:,:,1) * ( &
                                      &   - ( rab_n(:,:,1,jp_tem) + rab_pe(:,:,1,jp_tem) ) * tsn(:,:,1,jp_tem)    &
@@ -102,5 +100,5 @@
                                      & ) / e3t_n(:,:,1)
                                    CALL iom_put( "petrd_sad" , z2d )
-                                   CALL wrk_dealloc( jpi, jpj, z2d )
+                                   DEALLOCATE( z2d )
                                 ENDIF
       CASE ( jptra_ldf  )   ;   CALL iom_put( "petrd_ldf" , zpe )   ! lateral  diffusion
@@ -115,15 +113,14 @@
       CASE ( jptra_atf  )   ;   CALL iom_put( "petrd_atf" , zpe )   ! asselin time filter (last trend)
                                 !IF( ln_linssh ) THEN                   ! cst volume : ssh term (otherwise include in e3t variation)
-                                !   CALL wrk_alloc( jpi, jpj, z2d )
+                                !   ALLOCATE( z2d(jpi,jpj) )
                                 !   z2d(:,:) = ( ssha(:,:) - sshb(:,:) )                 &
                                 !      &     * (   dPE_dt(:,:,1) * tsn(:,:,1,jp_tem)    &
                                 !      &         + dPE_ds(:,:,1) * tsn(:,:,1,jp_sal)  ) / ( e3t_n(:,:,1) * pdt )
                                 !   CALL iom_put( "petrd_sad" , z2d )
-                                !   CALL wrk_dealloc( jpi, jpj, z2d )
+                                !   DEALLOCATE( z2d )
                                 !ENDIF
          !
       END SELECT
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zpe )
       !
    END SUBROUTINE trd_pen
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 9125)
@@ -28,5 +28,4 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! Memory allocation
 
    IMPLICIT NONE
@@ -91,8 +90,6 @@
       !
       INTEGER ::   ji, jj   ! dummy loop indices
-      REAL(wp), POINTER, DIMENSION(:,:) ::   ztswu, ztswv    ! 2D workspace 
-      !!----------------------------------------------------------------------
-
-      CALL wrk_alloc( jpi, jpj, ztswu, ztswv )
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztswu, ztswv    ! 2D workspace 
+      !!----------------------------------------------------------------------
 
       SELECT CASE( ktrd ) 
@@ -122,6 +119,4 @@
       END SELECT
       !
-      CALL wrk_dealloc( jpi, jpj, ztswu, ztswv )
-      !
    END SUBROUTINE trd_vor
 
@@ -160,9 +155,7 @@
       INTEGER ::   ji, jj       ! dummy loop indices
       INTEGER ::   ikbu, ikbv   ! local integers
-      REAL(wp), POINTER, DIMENSION(:,:) :: zudpvor, zvdpvor  ! total cmulative trends
-      !!----------------------------------------------------------------------
-
-      !
-      CALL wrk_alloc( jpi, jpj, zudpvor, zvdpvor )                                     ! Memory allocation
+      REAL(wp), DIMENSION(jpi,jpj) :: zudpvor, zvdpvor  ! total cmulative trends
+      !!----------------------------------------------------------------------
+
       !
 
@@ -210,6 +203,4 @@
          CALL FLUSH(numout)
       ENDIF
-      !
-      CALL wrk_dealloc( jpi, jpj, zudpvor, zvdpvor )                                   
       !
    END SUBROUTINE trd_vor_zint_2d
@@ -249,10 +240,8 @@
       !
       INTEGER ::   ji, jj, jk   ! dummy loop indices
-      REAL(wp), POINTER, DIMENSION(:,:) :: zubet  , zvbet    ! Beta.V   
-      REAL(wp), POINTER, DIMENSION(:,:) :: zudpvor, zvdpvor  ! total cmulative trends
+      REAL(wp), DIMENSION(jpi,jpj) :: zubet  , zvbet    ! Beta.V   
+      REAL(wp), DIMENSION(jpi,jpj) :: zudpvor, zvdpvor  ! total cmulative trends
       !!----------------------------------------------------------------------
      
-      CALL wrk_alloc( jpi,jpj, zubet, zvbet, zudpvor, zvdpvor )                                   
-
       ! Initialization
       zubet  (:,:) = 0._wp
@@ -306,6 +295,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj, zubet, zvbet, zudpvor, zvdpvor )                                   
-      !
    END SUBROUTINE trd_vor_zint_3d
 
@@ -323,8 +310,6 @@
       INTEGER  ::   it, itmod        ! local integers
       REAL(wp) ::   zmean            ! local scalars
-      REAL(wp), POINTER, DIMENSION(:,:) :: zun, zvn
-      !!----------------------------------------------------------------------
-
-      CALL wrk_alloc( jpi, jpj, zun, zvn )                                   
+      REAL(wp), DIMENSION(jpi,jpj) :: zun, zvn
+      !!----------------------------------------------------------------------
 
       !  =================
@@ -458,6 +443,4 @@
       IF( kt == nitend )   CALL histclo( nidvor )
       !
-      CALL wrk_dealloc( jpi, jpj, zun, zvn )                                   
-      !
    END SUBROUTINE trd_vor_iom
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/USR/usrdef_zgr.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/USR/usrdef_zgr.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/USR/usrdef_zgr.F90	(revision 9125)
@@ -23,5 +23,4 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE wrk_nemo       ! Memory allocation
 
    IMPLICIT NONE
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfiwm.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfiwm.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfiwm.F90	(revision 9125)
@@ -27,5 +27,4 @@
    USE iom            ! I/O Manager
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! work arrays
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/diawri.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/diawri.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/diawri.F90	(revision 9125)
@@ -43,5 +43,4 @@
    USE lib_mpp         ! MPP library
    USE timing          ! preformance summary
-   USE wrk_nemo        ! working array
 
    IMPLICIT NONE
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/C14/trcatm_c14.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/C14/trcatm_c14.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/C14/trcatm_c14.F90	(revision 9125)
@@ -45,5 +45,5 @@
       REAL(wp) ::   yn20 =  20.     ! 20 degrees north
       REAL(wp) ::   yn40 =  40.     ! 40 degrees north
-      REAL(wp), POINTER, DIMENSION(:)   :: zco2, zyrco2  ! temporary arrays for swap
+      REAL(wp), ALLOCATABLE, DIMENSION(:)   :: zco2, zyrco2  ! temporary arrays for swap
       !
       !!----------------------------------------------------------------------
@@ -78,6 +78,5 @@
       !
          IF(kc14typ==2) THEN
-            CALL wrk_alloc( nrecco2,zco2)
-            CALL wrk_alloc( nrecco2,zyrco2)
+            ALLOCATE( zco2(nrecco2), zyrco2(nrecco2) )
             zco2(:)=spco2(:)
             zyrco2(:)=tyrco2(:)
@@ -88,6 +87,5 @@
                tyrco2(izco2)=1950._wp-zyrco2(jn)         ! BP to AD dates
             END DO
-            CALL wrk_dealloc(nrecco2,zco2)
-            CALL wrk_dealloc(nrecco2,zyrco2)
+            DEALLOCATE( zco2,zyrco2 )
          ENDIF
       !
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/C14/trcwri_c14.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/C14/trcwri_c14.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/C14/trcwri_c14.F90	(revision 9125)
@@ -36,6 +36,6 @@
       INTEGER              :: ji,jj,jk,jn   ! dummy loop indexes
       REAL(wp)             :: zage,zarea,ztemp   ! temporary
-      REAL(wp), POINTER, DIMENSION(:,:)   :: zres, z2d ! temporary storage 2D
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: z3d , zz3d ! temporary storage 3D
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)   :: zres, z2d ! temporary storage 2D
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: z3d , zz3d ! temporary storage 3D
       !!---------------------------------------------------------------------
  
@@ -50,6 +50,6 @@
       IF( iom_use("DeltaC14") .OR. iom_use("C14Age") .OR. iom_use("RAge")   ) THEN
          !
-         CALL wrk_alloc( jpi, jpj     , z2d, zres )
-         CALL wrk_alloc( jpi, jpj, jpk, z3d, zz3d )
+         ALLOCATE( z2d(jpi,jpj), zres(jpi,jpj) )
+         ALLOCATE( z3d(jpi,jpj,jpk), zz3d(jpi,jpj,jpk) )
          !
          zage = -1._wp / rlam14 / rsiyea  ! factor for radioages in year
@@ -87,6 +87,5 @@
          CALL iom_put( "RAge" , zage * z2d(:,:) )                     ! Reservoir age [yr]
          !
-         CALL wrk_dealloc( jpi, jpj     , z2d, zres )
-         CALL wrk_dealloc( jpi, jpj, jpk, z3d, zz3d )
+         DEALLOCATE( z2d, zres, z3d, zz3d )
          !
       ENDIF
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 9125)
@@ -43,5 +43,5 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       INTEGER ::   jn   ! dummy loop index
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrmyt
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: ztrmyt
       !!----------------------------------------------------------------------
       !
@@ -52,5 +52,5 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
 
-      IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrmyt )
+      IF( l_trdtrc )  ALLOCATE( ztrmyt(jpi,jpj,jpk) )
 
       CALL trc_bc ( kt )       ! tracers: surface and lateral Boundary Conditions
@@ -64,5 +64,5 @@
             CALL trd_trc( ztrmyt, jn, jptra_sms, kt )   ! save trends
           END DO
-          CALL wrk_dealloc( jpi, jpj, jpk, ztrmyt )
+          DEALLOCATE( ztrmyt )
       END IF
       !
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zbio.F90	(revision 9125)
@@ -96,6 +96,6 @@
       REAL(wp) ::   znh4a, zdeta, zdoma, zzoobod, zboddet, zdomaju
       REAL(wp) ::   ze3t
-      REAL(wp), POINTER,   DIMENSION(:,:,:) :: zw2d
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) :: zw3d
+      REAL(wp), ALLOCATABLE,   DIMENSION(:,:,:) :: zw2d
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) :: zw3d
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -103,8 +103,5 @@
       IF( ln_timing )   CALL timing_start('p2z_bio')
       !
-      IF( lk_iomput ) THEN
-         CALL wrk_alloc( jpi, jpj,     17, zw2d )
-         CALL wrk_alloc( jpi, jpj, jpk, 3, zw3d )
-      ENDIF
+      IF( lk_iomput ) ALLOCATE( zw2d(jpi,jpj,17), zw3d(jpi,jpj,jpk,3) )
 
       IF( kt == nittrc000 ) THEN
@@ -377,8 +374,5 @@
       ENDIF
       !
-      IF( lk_iomput ) THEN
-         CALL wrk_dealloc( jpi, jpj,     17, zw2d )
-         CALL wrk_dealloc( jpi, jpj, jpk, 3, zw3d )
-      ENDIF
+      IF( lk_iomput ) DEALLOCATE( zw2d, zw3d )
       !
       IF( ln_timing )  CALL timing_stop('p2z_bio')
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zexp.F90	(revision 9125)
@@ -64,5 +64,5 @@
       INTEGER  ::   ji, jj, jk, jl, ikt
       REAL(wp) ::   zgeolpoc, zfact, zwork, ze3t, zsedpocd, zmaskt
-      REAL(wp), POINTER, DIMENSION(:,:)   ::  zsedpoca
+      REAL(wp), DIMENSION(jpi,jpj)   ::  zsedpoca
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -72,5 +72,4 @@
       IF( kt == nittrc000 )   CALL p2z_exp_init
 
-      CALL wrk_alloc( jpi, jpj, zsedpoca ) 
       zsedpoca(:,:) = 0.
 
@@ -147,6 +146,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, zsedpoca)   ! temporary save of trends
-
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('exp')")
@@ -167,6 +164,6 @@
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zmaskt, zfluo, zfluu
-      REAL(wp), POINTER, DIMENSION(:,:  ) ::   zrro
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zdm0
+      REAL(wp), DIMENSION(jpi,jpj    ) :: zrro
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zdm0
       !!---------------------------------------------------------------------
       !
@@ -178,8 +175,4 @@
       ENDIF
       !
-      ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      zrro )
-      CALL wrk_alloc( jpi, jpj, jpk, zdm0 )
-
 
       ! Calculate vertical distribution of newly formed biogenic poc
@@ -247,7 +240,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj,      zrro )
-      CALL wrk_dealloc( jpi, jpj, jpk, zdm0 )
-      !
    END SUBROUTINE p2z_exp_init
 
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 9125)
@@ -67,13 +67,10 @@
       REAL(wp) ::   zkr, zkg            ! total absorption coefficient in red and green
       REAL(wp) ::   zcoef               ! temporary scalar
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zpar100, zpar0m
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zparr, zparg
+      REAL(wp), DIMENSION(jpi,jpj    ) :: zpar100, zpar0m
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zparr, zparg
       !!---------------------------------------------------------------------
       !
       IF( ln_timing )   CALL timing_start('p2z_opt')
       !
-      ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj,      zpar100, zpar0m )
-      CALL wrk_alloc( jpi, jpj, jpk, zparr, zparg    )
 
       IF( kt == nittrc000 ) THEN
@@ -142,7 +139,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj,      zpar100, zpar0m )
-      CALL wrk_dealloc( jpi, jpj, jpk, zparr, zparg    )
-      !
       IF( ln_timing )   CALL timing_stop('p2z_opt')
       !
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 9124)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsed.F90	(revision 9125)
@@ -59,6 +59,6 @@
       INTEGER  ::   ji, jj, jk, jl, ierr
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zw2d
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zwork, ztra
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) :: zw2d
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zwork, ztra
       !!---------------------------------------------------------------------
       !
@@ -70,7 +70,4 @@
          IF(lwp) WRITE(numout,*) ' ~~~~~~~'
       ENDIF
-
-      ! Allocate temporary workspace
-      CALL wrk_alloc( jpi, jpj, jpk, zwork, ztra )
 
       ! sedimentation of detritus  : upstream scheme
@@ -98,5 +95,5 @@
       IF( lk_iomput )  THEN
          IF( iom_use( "TDETSED" ) ) THEN
-            CALL wrk_alloc( jpi, jpj, zw2d )
+            ALLOCATE( zw2d(jpi,jpj) )
             zw2d(:,:) =  ztra(:,:,1) * e3t_n(:,:,1) * 86400._wp
             DO jk = 2, jpkm1
@@ -104,9 +101,7 @@
             END DO
             CALL iom_put( "TDETSED", zw2d )
-            CALL wrk_dealloc( jpi, jpj, zw2d )
+            DEALLOCATE( zw2d )
          ENDIF
       ENDIF
-      !
-      CALL wrk_dealloc( jpi, jpj, jpk, zwork, ztra )
       !
 
